#include "DataMaker.h"

using namespace std;

void DataMaker::clean() {
	cout << "Filtering trades...\n" ;
	for(map<string,vector<Trade>>::iterator it = trades.begin(); it != trades.end(); it++) {
		unsigned n = filterTrades( it->second );
		cout << "Filtered " << n << " trades for " << it->first << '.' << endl;
	}
	cout << "Finished filtering trades!\n";
}

unsigned DataMaker::filterTrades(std::vector<Trade> &src) {
	const double HI_THRESH = 0.170 ;	// 20% change 
	const double LOW_THRESH = 0.100 ;
	const int MAX_COUNT = 10;

	vector<Trade> tmpvec ;
	tmpvec.reserve( src.size() ) ;

	vector<Trade>::const_iterator it=src.begin();

	double p0=it->price, p1=it->price;
	int tot_cnt=0,cnt=0;

	for(; it!=src.end(); ++it) {
		if( (it->time.time_of_day().hours() < 6) || (it->time.time_of_day().hours() > 18) ) {
			// irregular time messes up the candlestick generation
			tot_cnt ++;
		}
		else if(cnt == MAX_COUNT)
		{ 
			tot_cnt += MAX_COUNT;
			cnt = 0;
		}
		else if(cnt || (abs(it->price-p1) > p1*HI_THRESH)) {
			if((!cnt) && (p1!=p0) && (abs(it->price-p0) > p0*LOW_THRESH)) {
				// it was the previous one and not this one
				tmpvec.pop_back() ;
				p0 = (tmpvec.rbegin()+1)->price ;
				p1 = tmpvec.back().price ;
				-- it ;
				++ tot_cnt ;
				continue ;
			}
			else if(cnt && (abs(it->price-p1) < p1*LOW_THRESH)) {
				tot_cnt += cnt;
				cnt = 0;
				goto copy_trade ;
			}
			else {
				cnt ++ ;
			}
		}
		else if( (abs(it->price-p1) > p1*LOW_THRESH) && (abs((it+2)->price-p1) < p1*LOW_THRESH) ) {
			it ++ ; tot_cnt += 2 ;
		}
		else {
copy_trade:
			p0 = p1;
			p1 = it->price;
			tmpvec.push_back( *it ) ;
		}
	}

	src = tmpvec ;
	return tot_cnt ;
}