#include "DataMaker.h"

using namespace std;

void DataMaker::read() {
	cout << "Searching for files in " << indir << "..." << endl;

	fs::directory_iterator end_itr;
	for(fs::directory_iterator dir_itr(indir);
		dir_itr != end_itr; ++dir_itr) {
			cout << "Reading trades from " << dir_itr->path().string() << "..." << endl;

			ifstream in_file(dir_itr->path().string().c_str());

			if(in_file.is_open()) {
				unsigned n=readTrades(in_file);
				in_file.close();
				cout << "Finished reading " << n << " trades" << endl ;
			}
			else {
				std::string err = "Couldn't open the file: " + dir_itr->path().string() ;
				throw std::exception(err.c_str());
			}
	}

	cout << "Finished reading trades!\n" ;
}

unsigned DataMaker::readTrades(std::ifstream &file) {
	string line;
	string ticker;
	Trade t;
	unsigned n=0;
	while(!file.eof()) {
		getline(file,line);
		replace(line.begin(), line.end(), ',', '.');	// to make doubles parseable

		int dummy ;
		if( !!(iss >> ticker >> dummy >> t.time >> t.price >> t.volume) ) {
			// line was read OK
			trades[ticker].push_back(t) ;
			n++;
		}
	}

	return n ;
}