#pragma once

class TradeParser {
	istringstream iss;

public:
	TradeParser() {
		t::time_input_facet *facet = new t::time_input_facet("%d/%m/%Y %H:%M:%S%F");
		iss.imbue( locale(iss.getloc(), facet) );
	}

	// parses a string to a trade object
	bool parse_trade(std::string line, Trade &t, std::string &ticker) {	// t and ticker are output values
		replace( line.begin(), line.end(), ',', '.' );

		iss.clear();
		iss.str(line);

		t::ptime pt;
		int dummy;	// there is some weird value i don't know what it means
		double price;
		unsigned long volume;
		if( !(iss >> ticker >> dummy >> pt >> price >> volume ) ) {
			return false;	// failed to properly parse the values
		}

		t.setTime(pt);
		t.setPrice(price);
		t.setVolume(volume);

		return true;
	}
};